/* usbnapi.h
* Copyright (C) 2005  Benedikt Sauter
* Copyright (C) 2008  Manuel Stahl
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _USBNAPI_H
#define _USBNAPI_H

#include <avr/pgmspace.h>
#include "usbn960x.h"
#include "../usbn960xreg.h"


/**
 * Set USB device information.
 */
void USBNInit(uint8_t *_DeviceDescriptor,uint8_t *_ConfigurationDescriptor);

/**
 * Setup callback for fifo 1 rx
 */
void USBNCallbackFIFORX1(FIFOCallback* fct);

/**
 * Start usb system after configuration
 */
void USBNStart(void);

/**
 * Add new string descriptor from flash and get index
 * @param string	a constant string
 * @return index of string descriptor
 */
#define USBNAddStringDescriptor(s)	_USBNAddStringDescriptor_P(PSTR(s));

/**
 * Add a string descriptor to the array of known descriptors.
 * @param string	pointer to string in flash memory
 * @return index of string descriptor
 */
uint8_t _USBNAddStringDescriptor_P(char *string);


#endif /* __USBNAPI_H__ */
